#
# Conditional build:
%bcond_without	default_crypt	# build as default libcrypt provider

Summary:	Crypt Library for DES, MD5, and Blowfish
Summary(pl.UTF-8):	Biblioteka szyfrująca hasła obsługująca DES, MD5 i Blowfish
Name:		libxcrypt
Version:	4.4.33
Release:	1
License:	LGPL v2.1+
Group:		Libraries
#Source0Download: https://github.com/besser82/libxcrypt/releases
Source0:	https://github.com/besser82/libxcrypt/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	1cfd40c89ab1e3d4a1f030c9842474e9
Patch0:		%{name}-xcrypt.patch
URL:		https://github.com/besser82/libxcrypt
BuildRequires:	autoconf >= 2.62
BuildRequires:	automake >= 1:1.14
BuildRequires:	gcc >= 5:3.2
BuildRequires:	libltdl-devel
BuildRequires:	libtool >= 2:2
BuildRequires:	pkgconfig >= 1:0.27
%if %{with default_crypt}
Provides:	crypt(blowfish)
Obsoletes:	glibc-libcrypt
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%undefine	__cxx

%if %{with default_crypt}
%define		libname		libcrypt
%define		libver		1
%else
%define		libname		libxcrypt
%define		libver		2
%endif

%description
libxcrypt is a replacement for libcrypt, which comes with the GNU C
Library. It supports DES crypt, MD5, and passwords with Blowfish
encryption.

%description -l pl.UTF-8
libxcrypt to zamiennik biblioteki libcrypt dostarczanej wraz z
biblioteką GNU C (libc). Obsługuje szyfrowanie haseł DES, MD5 oraz
Blowfish.

%package devel
Summary:	Header file for libxcrypt
Summary(pl.UTF-8):	Plik nagłówkowy biblioteki libxcrypt
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%{?with_default_crypt:Conflicts:	glibc-devel-doc < 6:2.34-7}

%description devel
This package contains the header file to develop software using
libxcrypt.

%description devel -l pl.UTF-8
Ten pakiet zawiera plik nagłówkowy pozwalający na tworzenie programów
korzystających z libxcrypt.

%package static
Summary:	Static libxcrypt library
Summary(pl.UTF-8):	Statyczna biblioteka libxcrypt
License:	LGPL v2.1+
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
This package contains the static libxcrypt library used for
development.

%description static -l pl.UTF-8
Ten pakiet zawiera statyczną wersję biblioteki libxcrypt.

%prep
%setup -q
%{!?with_default_crypt:%patch0 -p1}

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
%if %{with default_crypt}
	--enable-obsolete-api=glibc \
	--enable-obsolete-api-enosys=yes \
%else
	--includedir=%{_includedir}/xcrypt \
	--disable-xcrypt-compat-files \
%endif
	--disable-werror
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{_lib}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__mv} $RPM_BUILD_ROOT%{_libdir}/%{libname}.so.* $RPM_BUILD_ROOT/%{_lib}
ln -snf /%{_lib}/$(basename $RPM_BUILD_ROOT/%{_lib}/%{libname}.so.*.*.*) $RPM_BUILD_ROOT%{_libdir}/%{libname}.so

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/%{libname}.la

%if %{without default_crypt}
# PLD doesn't need Owl compatibility
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libowcrypt.*
# packaged with glibc-devel
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man3/crypt{,_r,_ra,_rn}.3*
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%posttrans
if [ ! -L /%{_lib}/%{libname}.so.%{libver} ]; then
	%{__rm} -f /%{_lib}/%{libname}.so.%{libver}
	/sbin/ldconfig
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog LICENSING NEWS README.md THANKS TODO.md
%attr(755,root,root) /%{_lib}/%{libname}.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/%{libname}.so.%{libver}

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{libname}.so
%if %{with default_crypt}
%{_includedir}/crypt.h
%{_includedir}/xcrypt.h
%attr(755,root,root) %{_libdir}/libxcrypt.so
%else
%{_includedir}/xcrypt
%endif
%{_pkgconfigdir}/libcrypt.pc
%{_pkgconfigdir}/libxcrypt.pc
%{_mandir}/man3/crypt_checksalt.3*
%{_mandir}/man3/crypt_gensalt*.3*
%{_mandir}/man3/crypt_preferred_method.3*
%if %{with default_crypt}
%{_mandir}/man3/crypt.3*
%{_mandir}/man3/crypt_r.3*
%{_mandir}/man3/crypt_ra.3*
%{_mandir}/man3/crypt_rn.3*
%endif
%{_mandir}/man5/crypt.5*

%files static
%defattr(644,root,root,755)
%{_libdir}/%{libname}.a
%if %{with default_crypt}
%{_libdir}/libxcrypt.a
%endif
%changelog
* Tue Nov 22 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libxcrypt.git;a=log;h=master

* Fri Nov 18 2022 Jan Palus <atler@pld-linux.org> b8dea59
- up to 4.4.33

* Mon Nov 14 2022 Jan Palus <atler@pld-linux.org> 4d82356
- up to 4.4.31

* Tue Nov 01 2022 Jan Palus <atler@pld-linux.org> cf9211c
- up to 4.4.30

* Tue Nov 01 2022 Jan Palus <atler@pld-linux.org> 77c418b
- up to 4.4.29

* Sat Dec 18 2021 Jan Palus <atler@pld-linux.org> 04fe7a7
- C: glibc-devel-doc only when building with default crypt

* Sat Dec 18 2021 Jan Palus <jpalus@fastmail.com> 7e90480
- up to 4.4.27

* Fri Dec 17 2021 Jan Palus <jpalus@fastmail.com> c0db772
- add C: glibc-devel-doc (before crypt switch) to -devel

* Fri Dec 03 2021 Jakub Bogusz <qboosh@pld-linux.org> 7de2424
- updated to 4.4.26

* Wed Nov 17 2021 Jan Rękorajski <baggins@pld-linux.org> 7bd10e8
- cleanup glibc-libcrypt leftover in posttrans, rel 3

* Fri Nov 12 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> f8fd684
- Rel 2; be default crypt provider for glibc

* Fri Aug 13 2021 Jan Palus <atler@pld-linux.org> fee2e5f
- up to 4.4.25

* Wed Aug 04 2021 Jan Palus <atler@pld-linux.org> 8a0e07d
- up to 4.4.24

* Mon Jun 21 2021 Jan Palus <atler@pld-linux.org> 496a9cf
- up to 4.4.23

* Thu Jun 10 2021 Jan Palus <atler@pld-linux.org> f35557c
- up to 4.4.22

* Tue Apr 13 2021 Jan Palus <atler@pld-linux.org> 44a6006
- up to 4.4.19

* Fri Feb 26 2021 Jakub Bogusz <qboosh@pld-linux.org> e0e7ded
- updated xcrypt patch

* Thu Feb 25 2021 Jan Palus <atler@pld-linux.org> 4e11022
- up to 4.4.18

* Sun Oct 25 2020 Jakub Bogusz <qboosh@pld-linux.org> 39d43e4
- explicit /usr/include/*.h files (in default_crypt case)

* Sun Oct 25 2020 Jan Palus <atler@pld-linux.org> f7f4363
- don't customize _includedir when building as default crypt

* Mon Aug 24 2020 Jan Palus <atler@pld-linux.org> 0f4884b
- add bcond for building as libcrypt replacement

